




<!DOCTYPE html>
<html>
<head>
<title>【PyTorch深度学习60分钟快速入门 】Part3：神经网络 -  码上快乐</title>
<meta name="keywords" content="PyTorch,深度学习,神经网络" />
<meta name="description" content=" nbsp 神经网络可以通过使用torch.nn包来构建。 既然你已经了解了autograd，而nn依赖于autograd来定义模型并对其求微分。一个nn.Module包含多个网络层，以及一个返回输出的方法forward input 。 例如，查看下图中的对数字图片分类的网络： 这是一个简单的前馈网" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta http-equiv="X-UA-Compatible" content="ie=edge">
<meta http-equiv="Cache-Control" content="no-transform" />
<meta http-equiv="Cache-Control" content="no-siteapp" />
<meta name="applicable-device" content="pc,mobile">
<link href="/css/all.css?version=" rel="stylesheet">
<link href="/css/prettify.css?version=" rel="stylesheet">
</head>
<body onload="prettyPrint()">
    
<style>
.div2{top:45px;z-index:999;position:fixed;_position:absolute}
</style>
<div class="navbar navbar-inverse navbar-fixed-top">
	<div class="navbar-inner">
		<div class="container">
			<button data-target=".nav-collapse" data-toggle="collapse" class="btn btn-navbar" type="button">
				<span class="icon-bar"></span> 
				<span class="icon-bar"></span>
				<span class="icon-bar"></span>
			</button>
			<a class="brand" href="/index.html">码上快乐</a>
			<div class="nav-collapse collapse">
                <p class="navbar-text pull-right toplogin" style="margin-top:0px;">
	              <a href="javascript:void(0)" class="btn-show-login navbar-link">1秒登录</a>
	            </p>		
				<ul class="nav">
					<li class="navtop index"><a href="/index.html"><i class="icon-home icon-white"></i><strong>首页</strong></a></li>
					<li class="navtop recent"><a href="/rank.html"><i class="icon-fire icon-white"></i><strong>榜单</strong></a></li>
					<li class="navtop tags"><a href="/tags.html"><i class="icon-tag icon-white"></i><strong>标签</strong></a></li>
					<li class="navtop hot"><a href="/about.html"><i class="icon-heart icon-white"></i><strong>关于</strong></a></li>
					<li class="navtop hot"><a href="javascript:void(0);" rel="nofollow"><i class="icon-fire icon-white"></i><strong style="color:red" class="gptclass"></strong></a></li>
				</ul>
			</div>
		</div>
	</div>
</div>
<script src="/js/all.js?version="></script>

<!-- Global site tag (gtag.js) - Google Analytics -->

    <input name="ua" value="" type="hidden"/>
    <input name="title" value="【PyTorch深度学习60分钟快速入门 】Part3：神经网络" type="hidden"/>
	<div class="container" style="padding-top:20px;">
		<div class="row-fluid m_b_20">
		    
			<div class="span2 visible-desktop" id="logo">
				<center>
					<a href="/index.html"><img src="/img/logo.png?version=" class="h_30"/></a>
				</center>
			</div>
			<div class="span6">
				<form class="form-search" action="/so" name="search-form">
					<div class="input-append span10">
						<center>
							<input type="text" class="span12 search-query" name="q" placeholder=" 请输入关键词搜索..." baiduSug="1">
							<button type="submit" class="btn btn-warning">搜索</button>
						</center>
					</div>
				</form>
			</div>
			<div class="span4 visible-desktop">
			    <a class="btn" href="/recommend/7ffcbb1/PyTorch深度学习-分钟快速入门-Part-神经网络"><i class="icon-random"></i>相关内容</a>
			    &nbsp;&nbsp;<a class="btn" href="https://www.codeprj.com/blog/7ffcbb1.html"><i class="icon-refresh"></i>简体</a>
			    &nbsp;&nbsp;<a class="btn" href="https://www.codeprj.com/zh/blog/7ffcbb1.html"><i class="icon-refresh"></i>繁体</a>
				
			</div>
		</div>
		<div class="row-fluid">
		    
			<div class="span8">
			    <div class="content_div">
			      <center>
			      <h3><a href="/blog/7ffcbb1.html" style="color:black">【PyTorch深度学习60分钟快速入门 】Part3：神经网络</a></h3>
			      </center>
			      <div class="postinfo">
			              本文转载自
			      
			      <i class="icon-globe"></i>&nbsp;<a href="/go/aHR0cHM6Ly93d3cuY25ibG9ncy5jb20vbGVlamFjay9wLzgzODc3NzEuaHRtbA==" target="_blank">查看原文</a>
			      <i class="icon-time"></i>&nbsp;<span>2018-01-30 23:04</span>
			      <i class="icon-eye-open"></i>&nbsp;<span>1274&nbsp;</span>
                  
                     <i class="icon-tag"></i>&nbsp;
                     
                     
                     
                     <span><a href='/tag/PyTorch' target="_blank">PyTorch</a>/</span>
                                          
                     
                     <span><a href='/tag/深度学习' target="_blank">深度学习</a>/</span>
                                          
                     
                     
                     <span><a href='/tag/神经网络' target="_blank">神经网络</a></span>                     
                     
                  
                  <i class="icon-star" title="1.3889"></i>
                  
                  
                  
                                    
			      </div>
			      <hr/>
                 <div class="media-body" id="content_div">
                    <div class="title_down_ad ad">
					</div>
					<div class="post_content" id="postContent">
					  <p>&nbsp;</p> 
<p>神经网络可以通过使用<code>torch.nn</code>包来构建。</p> 
<p>既然你已经了解了<code>autograd</code>，而<code>nn</code>依赖于<code>autograd</code>来定义模型并对其求微分。一个<code>nn.Module</code>包含多个网络层，以及一个返回输出的方法<code>forward(input)</code> 。</p> 
<p>例如，查看下图中的对数字图片分类的网络：</p> 
<p><img src="/image/aHR0cHM6Ly9maWxlcy5jbmJsb2dzLmNvbS9maWxlcy9sZWVqYWNrL21uaXN0LmJtcA==.png" alt="" loading="lazy" referrerpolicy="no-referrer"></p> 
<p>这是一个简单的前馈网络。它接受输入，并将输入依次通过多个层，然后给出输出结果。<br> 对于神经网络来说，一个经典的训练过程包括以下步骤：</p> 
<ul> 
 <li>定义一个包含一些可学习的参数（或权重）的神经网络</li> 
 <li>对输入数据集进行迭代</li> 
 <li>通过网络处理输入</li> 
 <li>计算损失函数（即输出距离正确值差多远）</li> 
 <li>将梯度传播回网络参数</li> 
 <li>更新网络的权重，通常使用一个简单的更新规则：<code>weight = weight - learning_rate * gradient</code></li> 
</ul>
<ins class="adsbygoogle" style="display:block; text-align:center;" data-ad-layout="in-article" data-ad-format="fluid" data-ad-client="ca-pub-4353345653789615" data-ad-slot="4890554435"></ins>
<script>     (adsbygoogle = window.adsbygoogle || []).push({});</script> 
<h2 id="0x01-定义网络">0x01 定义网络</h2> 
<p>下面，我们定义该网络：</p> 
<pre><code class="language-python">import torch
from torch.autograd import Variable
import torch.nn as nn
import torch.nn.functional as F


class Net(nn.Module):

    def __init__(self):
        super(Net, self).__init__()
        # 1 input image channel, 6 output channels, 5x5 square convolution
        # kernel
        self.conv1 = nn.Conv2d(1, 6, 5)
        self.conv2 = nn.Conv2d(6, 16, 5)
        # an affine operation: y = Wx + b
        self.fc1 = nn.Linear(16 * 5 * 5, 120)
        self.fc2 = nn.Linear(120, 84)
        self.fc3 = nn.Linear(84, 10)

    def forward(self, x):
        # Max pooling over a (2, 2) window
        x = F.max_pool2d(F.relu(self.conv1(x)), (2, 2))
        # If the size is a square you can only specify a single number
        x = F.max_pool2d(F.relu(self.conv2(x)), 2)
        x = x.view(-1, self.num_flat_features(x))
        x = F.relu(self.fc1(x))
        x = F.relu(self.fc2(x))
        x = self.fc3(x)
        return x

    def num_flat_features(self, x):
        size = x.size()[1:]  # all dimensions except the batch dimension
        num_features = 1
        for s in size:
            num_features *= s
        return num_features


net = Net()
print(net)
</code></pre> 
<p>输出结果为：</p>
<ins class="adsbygoogle" style="display:block; text-align:center;" data-ad-layout="in-article" data-ad-format="fluid" data-ad-client="ca-pub-4353345653789615" data-ad-slot="4890554435"></ins>
<script>     (adsbygoogle = window.adsbygoogle || []).push({});</script> 
<pre><code>Net(
  (conv1): Conv2d (1, 6, kernel_size=(5, 5), stride=(1, 1))
  (conv2): Conv2d (6, 16, kernel_size=(5, 5), stride=(1, 1))
  (fc1): Linear(in_features=400, out_features=120)
  (fc2): Linear(in_features=120, out_features=84)
  (fc3): Linear(in_features=84, out_features=10)
)
</code></pre> 
<p>你只需要定义前向（forward）函数，而反向（backward）函数（梯度计算的位置）会使用<code>autograd</code>自动为你定义。你可以在前向函数中使用任何张量操作。</p> 
<p>一个模型的可学习参数由<code>net.parameters()</code>返回。</p> 
<pre><code class="language-python">params = list(net.parameters())
print(len(params))
print(params[0].size())  # conv1's .weight
</code></pre> 
<p>输出结果：</p> 
<pre><code>10
torch.Size([6, 1, 5, 5])
</code></pre> 
<p>前向输入是一个<code>autograd.Variable</code>，输出也是如此。注意：该网络（LeNet）的预期输入大小为32x32。要在MNIST数据集上使用该网络，需要将该数据集中的图片大小调整为32x32。</p>
<ins class="adsbygoogle" style="display:block; text-align:center;" data-ad-layout="in-article" data-ad-format="fluid" data-ad-client="ca-pub-4353345653789615" data-ad-slot="4890554435"></ins>
<script>     (adsbygoogle = window.adsbygoogle || []).push({});</script> 
<pre><code class="language-python">input = Variable(torch.randn(1, 1, 32, 32))
out = net(input)
print(out)
</code></pre> 
<p>输出结果：</p> 
<pre><code>Variable containing:
 0.0023 -0.0613 -0.0397 -0.1123 -0.0397  0.0330 -0.0656 -0.1231  0.0412  0.0162
[torch.FloatTensor of size 1x10]
</code></pre> 
<p>将所有参数的梯度缓冲区置为零，并使用随机梯度进行后向传播：</p> 
<pre><code class="language-python">net.zero_grad()
out.backward(torch.randn(1, 10))
</code></pre> 
<p><strong>注意：</strong> <code>torch.nn</code>只支持小批量，整个<code>torch.nn</code>包都只支持小批量样本的输入，而不支持单个样本。例如，<code>nn.Conv2d</code>将接受一个4维的张量<code>nSamples x nChannels x Height x Width</code>。如果你只有单个样本，那么只需要使用<code>input.unsqueeze(0)</code>来添加一个假的批量维度。</p> 
<p>在继续之前，让我们回顾一下你目前所见到的所有类。</p> 
<p><strong>简要回顾：</strong></p> 
<ul> 
 <li><code>torch.Tensor</code>：一个多维数组。</li> 
 <li><code>autograd.Variable</code>：封装了一个张量和对该张量操作的记录历史。除了与张量具有相同的API外，还拥有一些如<code>backward()</code>等的操作。此外，还持有对张量的梯度w.r.t.。</li> 
 <li><code>nn.Module</code>：神经网络模块。一种封装参数的便捷方式，并含有将参数移到GPU、导出、加载等的辅助功能。</li> 
 <li><code>nn.Parameter</code>：一种变量，当作为一个属性分配给一个模块时，它会自动注册为一个参数。</li> 
 <li><code>autograd.Function</code>：实现<code>autograd</code>操作的前向和后向定义。每个变量操作，至少创建一个单独的函数节点，连接到创建了一个变量的函数，并对其历史进行编码。</li> 
</ul>
<ins class="adsbygoogle" style="display:block; text-align:center;" data-ad-layout="in-article" data-ad-format="fluid" data-ad-client="ca-pub-4353345653789615" data-ad-slot="4890554435"></ins>
<script>     (adsbygoogle = window.adsbygoogle || []).push({});</script> 
<p><strong>在本节，我们学习了以下内容：</strong></p> 
<ul> 
 <li>定义一个神经网络</li> 
 <li>处理输入及后向调用</li> 
</ul> 
<p><strong>剩余技能：</strong></p> 
<ul> 
 <li>计算损失</li> 
 <li>更新网络权重</li> 
</ul> 
<h2 id="0x02-损失函数（loss-function）">0x02 损失函数（Loss Function）</h2> 
<p>损失函数接受（输出，目标）输入对，并计算一个值，该值能够评估输出与目标的偏差大小。</p> 
<p><code>nn</code>包中有几个不同的损失函数。一个简单的损失函数是<code>nn.MSELoss</code>，它会计算输入和目标之间的均方误差。</p> 
<p>例如：</p> 
<pre><code class="language-python">output = net(input)
target = Variable(torch.arange(1, 11))  # a dummy target, for example
criterion = nn.MSELoss()

loss = criterion(output, target)
print(loss)
</code></pre> 
<p>输出结果：</p> 
<pre><code>Variable containing:
 38.8243
[torch.FloatTensor of size 1]
</code></pre> 
<p>现在，如果你沿着后向跟踪损失，那么可以使用它的``.grad_fn`属性，你将会看到一个这样的计算图：</p> 
<pre><code>input -&gt; conv2d -&gt; relu -&gt; maxpool2d -&gt; conv2d -&gt; relu -&gt; maxpool2d
      -&gt; view -&gt; linear -&gt; relu -&gt; linear -&gt; relu -&gt; linear
      -&gt; MSELoss
      -&gt; loss
</code></pre> 
<p>所以，当我们调用<code>loss.backward()</code>时，整个计算图是对损失函数求微分后的，并且图中所有的变量将使自己的<code>.grad</code>变量与梯度进行累积。</p> 
<p>为了便于展示，我们反向跟随几步：</p> 
<pre><code class="language-python">print(loss.grad_fn)  # MSELoss
print(loss.grad_fn.next_functions[0][0])  # Linear
print(loss.grad_fn.next_functions[0][0].next_functions[0][0])  # ReLU
</code></pre> 
<p>输出结果：</p> 
<pre><code>&lt;MseLossBackward object at 0x7fe4c18539e8&gt;
&lt;AddmmBackward object at 0x7fe3f5498550&gt;
&lt;ExpandBackward object at 0x7fe4c18539e8&gt;
</code></pre> 
<h2 id="0x03--反向传播（backprop）">0x03 反向传播（Backprop）</h2> 
<p>为了反向传播误差，我们所要做的就是调用<code>loss.backward()</code>。不过，你需要清除现有的梯度，否则梯度就会累积到已有的梯度上。</p> 
<p>现在我们应该调用<code>loss.backward()</code>，并在反向之前和之后查看conv1的偏差梯度。</p> 
<pre><code class="language-python">net.zero_grad()     # zeroes the gradient buffers of all parameters

print('conv1.bias.grad before backward')
print(net.conv1.bias.grad)

loss.backward()

print('conv1.bias.grad after backward')
print(net.conv1.bias.grad)
</code></pre> 
<p>输出结果：</p> 
<pre><code>conv1.bias.grad before backward
Variable containing:
 0
 0
 0
 0
 0
 0
[torch.FloatTensor of size 6]

conv1.bias.grad after backward
Variable containing:
1.00000e-02 *
  7.4571
 -0.4714
 -5.5774
 -6.2058
  6.6810
  3.1632
[torch.FloatTensor of size 6]
</code></pre> 
<p>现在，我们已经看到了如何使用损失函数。</p> 
<p><strong>扩展阅读：</strong><br> 神经网络包中包含各种各样的模块和损失函数，它们构成了深度神经网络的构造块。完整的文档列表可以在<a href="/link/aHR0cDovL3B5dG9yY2gub3JnL2RvY3Mvbm4=" rel="nofollow noopener" target="_blank">这里</a>查看。</p> 
<p><strong>唯一剩下的待学习的知识点：</strong></p> 
<ul> 
 <li>更新网络的权重</li> 
</ul> 
<h2 id="0x04-更新权重">0x04 更新权重</h2> 
<p>在实践中使用的最简单的更新规则是随机梯度下降法（Stochastic Gradient Descent，SGD）：<br> <code>weight = weight - learning_rate * gradient</code><br> 我们可以使用简单的python代码实现这一点：</p> 
<pre><code class="language-python">learning_rate = 0.01
for f in net.parameters():
    f.data.sub_(f.grad.data * learning_rate)
</code></pre> 
<p>然而，当你使用神经网络时，你可能想使用各种不同的更新规则，如SGD、Nesterov-SGD、Adam、RMSProp等等。为了实现这一点，我们构建了一个小的工具包<code>torch.optim</code>，它实现了所有这些方法。使用它非常简单：</p> 
<pre><code class="language-python">import torch.optim as optim

# create your optimizer
optimizer = optim.SGD(net.parameters(), lr=0.01)

# in your training loop:
optimizer.zero_grad()   # zero the gradient buffers
output = net(input)
loss = criterion(output, target)
loss.backward()
optimizer.step()    # Does the update
</code></pre> 
<p><strong>注意：</strong><br> 要观察梯度是如何缓存的，需要手动调用<code>optimizer.zero_grad()</code>将缓冲器设置为0。这是因为梯度会累积，正如在“反向传播”一节中解释的那样。</p> 
<p>脚本总运行时间：0分0.129秒。</p>
					</div>      
                    <div class="read-more" id="read-more" style="display:none"></div>        
                    <div class="alert alert-info" style="margin-top:20px;">
				      <p id="tips_top1">
				      </p>
			        </div>
			        <script type="text/javascript">
			         $("#tips_top1").append("<strong><i class=\"icon-fire\"></i>温馨提示：</strong>如果本文未解决您的问题，可以免费向大模型提问：<strong><a href='javascript:void(0)' class='gptbtn'>向AI大模型提问</a></strong>。");
			        </script>				        
					<div class="iframe-container">
					</div>
                 </div>
                 
			      
			      <div class="ad_content_down ad">
			      </div>                 
			    </div>
			     
			     <div class="disclaimer visible-desktop">
			         <br/>
		             <div class="alert alert-block">
		              <button type="button" class="close" data-dismiss="alert">×</button>
		              <h4>免责声明！</h4>
		                 <p>本站转载的文章为个人学习借鉴使用，本站对版权不负任何法律责任。如果侵犯了您的隐私权益，请联系本站邮箱yoyou2525@163.com删除。</p>
		            </div>	
		            <br/><br/>
                 </div>
			</div>
			
			<!-- 右边相关博客和资料 -->
			<div class="span4 left_content">
			  <div id="left_list_div" class="left_content">
			   <span class="list-group-item" href="javascript:void(0)"><i class="icon-filter"></i><strong>猜您在找</strong></span>
			   
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/7fb9ca1.html" title="【PyTorch深度学习60分钟快速入门 】Part1：PyTorch是什么？">
			           
			           <i class="icon-file"></i>
			           【PyTorch深度学习60分钟快速入门 】Part1：PyTorch是什么？
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/8000a81.html" title="【PyTorch深度学习60分钟快速入门 】Part4：训练一个分类器">
			           
			           <i class="icon-file"></i>
			           【PyTorch深度学习60分钟快速入门 】Part4：训练一个分类器
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/efdf081.html" title="PYTORCH: 60分钟 | 神经网络">
			           
			           <i class="icon-file"></i>
			           PYTORCH: 60分钟 | 神经网络
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/7652901.html" title="PyTorch深度学习：60分钟入门(Translation)">
			           <i class="icon-fire"></i>
			           
			           PyTorch深度学习：60分钟入门(Translation)
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/a6e3d61.html" title="Vue.js——60分钟快速入门">
			           <i class="icon-fire"></i>
			           
			           Vue.js——60分钟快速入门
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/55bd7e1.html" title="Vue.js——60分钟快速入门">
			           <i class="icon-fire"></i>
			           
			           Vue.js——60分钟快速入门
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/8ac8be1.html" title="Vue.js——60分钟快速入门">
			           <i class="icon-fire"></i>
			           
			           Vue.js——60分钟快速入门
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/5bece91.html" title="Vue.js——60分钟快速入门">
			           <i class="icon-fire"></i>
			           
			           Vue.js——60分钟快速入门
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/4990211.html" title="60分钟Python快速学习(给发哥一个交代)">
			           
			           <i class="icon-file"></i>
			           60分钟Python快速学习(给发哥一个交代)
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/bb092b1.html" title="深度学习——卷积神经网络入门">
			           
			           <i class="icon-file"></i>
			           深度学习——卷积神经网络入门
			           </a>
			       			       
			   
			   
			   <div id="right_float_ad" class="ad">
				</div>
			</div>
			</div>
		</div>
	</div>
    <div class="clear">&nbsp;</div>
    



<div class="fbar" style="z-index:100">
	<div class="span7" style="color:grey;font-size:12px;">
	</div>
	<div class="pull-right">
		<span><a href="http://beian.miit.gov.cn" rel="nofollow" target="_blank">粤ICP备18138465号</a>&nbsp;&nbsp;</span><span>&copy; 2018-2024 CODEPRJ.COM </span> 
	</div>
</div>
<script src="/js/code.js?version=20240328"></script>
<script>
   function buffer(a, b, c) {
	    var d;
	    return function() {
	        if (d) return;
	        d = setTimeout(function() {
	            a.call(this),
	            d = undefined
	        },
	        b)
	    }
	} 

	(function() {
	    function e() {
	        var d = document.body.scrollTop || document.documentElement.scrollTop;
	        d > b ? (a.className = "div1 div2", c && (a.style.top = d - b + "px")) : a.className = "div1"
	    }
	    var a = document.getElementById("float");
	    if (a == undefined) return ! 1;
	    var b = 0,
	    c, d = a;
	    while (d) b += d.offsetTop,
	    d = d.offsetParent;
	    c = window.ActiveXObject && !window.XMLHttpRequest;
	    if (!c || !0) window.onscroll = buffer(e, 50, this)
	})(); 

</script>

<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?85c5e8e7b6167edfc87cb0607142e870";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

    
    
</body>
</html>